//+------------------------------------------------------------------+
//|                                                  61 HiLo 1.3.mq4 |
//|                                                           Contra |
//|                                            http://www.contra.com |
//+------------------------------------------------------------------+
#property copyright "Contra"
#property link      "http://www.contra.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 clrLime
#property indicator_color2 clrRed
#property indicator_color3 clrYellow
#property indicator_color4 clrYellow
#property indicator_width1 2
#property indicator_width2 2
//---- input parameters
extern int       Range   = 210;
extern int       MaxBars = 100;
extern color     Color_UP    = clrWhite;
extern color     Color_DOWN  = clrWhite;
extern int       razmer_strelok  = 3;
//extern int       Alert = false;
//---- buffers
double Up[];
double Dn[];
double ur1[];
double ur2[];
double h1[];
double l1[];
//-----
int cb;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexArrow(1,159);
   SetIndexBuffer(0,Up);
   SetIndexBuffer(1,Dn);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(0,"HL_Act_Up");
   SetIndexLabel(1,"HL_Act_Dn");
   SetIndexBuffer(2,ur1);
   SetIndexBuffer(3,ur2);
   SetIndexBuffer(4,h1);
   SetIndexBuffer(5,l1);
   IndicatorDigits(Digits());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//------   
   int limit, counted_bars=IndicatorCounted();
   int n=0, Nbar=0, k=0, hh=0, ll=0, mm=0;

   double MaH=0.0, MaL=0.0;   
   if(counted_bars < 0)return(-1);
//----
   if(counted_bars > 0)counted_bars--;
   limit = Bars - counted_bars;
   if(limit>MaxBars)limit=MaxBars;
for( cb=limit; cb>=0; cb--)

     {
      Nbar=-1;
      k=1;
      mm=0;
      Dn[cb]=0.0;
      Up[cb]=0.0;
      ur1[cb]=0.0;
      ur2[cb]=0.0;
      h1[cb]=0.0;
      l1[cb]=0.0;
      //-----------------------------------------------------------------------------
                        if(Period()== 1)//  - W1
                          {
                           if(TimeMonth(Time[cb+1])!=TimeMinute(Time[cb]) )
                             {
                              n=cb-8;
                              //while( n<=cb+Range*100 )
                              while( n<=cb+Range )
                                {
                                 if(n<0 )
                                   {
                                    Nbar=0;
                                    n=1;
                                   }
                                 if(TimeMonth(Time[n+1])!=TimeMinute(Time[n]) )
                                   {
                                    if(Nbar==-1 )
                                      {
                                       Nbar=n;
                                       mm=n;
                                       n++;
                                       continue;
                                      }
                                    else
                                      {
                                       h1[k]=High[Highest(NULL,0,MODE_HIGH,(n-Nbar),n)];
                                       l1[k]=Low[Lowest(NULL,0,MODE_LOW,(n-Nbar),n)];
                                       k++;
                                       Nbar=n;
                                      }
                                   }
                                 n++;
                                }
                              MaH=0;
                              MaL=0;
                              for( n=1;n<=Range;n++ )
                                {
                                 MaH=MaH+h1[n];
                                 MaL=MaL+l1[n];
                                }
                              MaH=MaH/Range;
                              MaL=MaL/Range;
                              ur1[cb]=MaH;
                              ur2[cb]=MaL;
                              if(Close[mm+1]>=MaH )
                                {
                                 ll=1;
                                 hh=0;
                                }
                              if(Close[mm+1]<=MaL )
                                {
                                 hh=1;
                                 ll=0;
                                }
                             }
                           if(ur1[cb]==0 )
                             {
                              ur1[cb]=ur1[cb+1];
                              ur2[cb]=ur2[cb+1];
                             }
                           if(ll==1 )
                             {
                              Up[cb]=ur2[cb];
                             }
                           else
                             {
                              if(hh==1 )
                                {
                                 Dn[cb]=ur1[cb];
                                }
                              }
                            }
      //-----------------------------------------------------------------------------
      if (Dn[cb+1]==0.0 && Dn[cb]!=0.0)
        {
         //if(cb==0) Alert("  !!!  :)   .");
         SetSymbol("sell_sig",cb,0,Time[cb],High[cb]+20*Point,Color_DOWN,razmer_strelok ,226);
        }
      if (Up[cb+1]==0.0 && Up[cb]!=0.0)
        {
         //if(cb==0) Alert("  !!!  :)   .");
         SetSymbol("buy_sig",cb,0,Time[cb],Low[cb]-20*Point,Color_UP,razmer_strelok ,225);
        }
     }
//-----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetSymbol(string txt,int _cb,int win,datetime stime, double sprice,int scol,int swidth,int scode)
  {
//---- 
   if(ObjectFind(txt+" "+(string)_cb)==-1)
     {
      ObjectCreate(txt+" "+(string)_cb,OBJ_ARROW,win,stime,sprice);
      ObjectSet(txt+" "+(string)_cb,OBJPROP_COLOR,scol);
      ObjectSet(txt+" "+(string)_cb,OBJPROP_WIDTH,swidth);
      ObjectSet(txt+" "+(string)_cb,OBJPROP_ARROWCODE,scode);
     }
   else
     {
      ObjectMove(txt+" "+(string)_cb,0,stime,sprice);
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
  int deinit() 
  {
//---- TODO: add your code here
   int _cb;
   for(_cb=Bars-1-Range;_cb>=0;_cb--)
     {
      if(ObjectFind("buy_sig "+(string)_cb)!=-1 )
        {
         ObjectDelete("buy_sig "+(string)_cb);
        }
      else
        {
         if(ObjectFind("sell_sig "+(string)_cb)!=-1)
           {
            ObjectDelete("sell_sig "+(string)_cb);
           }
        }
     }
//----
   return(0);
  }